image: node:8-alpine

stages:
  - requirements
  - analyze
  - init
  - build
  - deploy
    
get_dependencies:
  stage: requirements
  script:
   - apk update
   - npm install
  cache:
   paths:
    - node_modules/
  artifacts:
    paths:
      - node_modules/

lint:
  stage: analyze
  script:
    - npm run lint
  allow_failure: true
      
analyze:
  stage: analyze
  image: ciricihq/gitlab-sonar-scanner
  script:
    - sonar-scanner -Dsonar.host.url=https://sonarqube.messenkrypt.xyz -Dsonar.gitlab.project_id=$CI_PROJECT_ID -Dsonar.projectVersion=$CI_BUILD_ID -Dsonar.gitlab.commit_sha=CI_COMMIT_SHA -Dsonar.gitlab.ref_name=$CI_BUILD_REF_NAME -Dsonar.login=$SONAR_TOKEN
  allow_failure: true

init-develop:
  stage: init
  script:
     - echo "VUE_APP_ROOT_API=https://api.messenkrypt.xyz" > .env
     - echo "VUE_APP_ROOT_API=https://api.messenkrypt.xyz" > .env.production
     #- echo "VUE_APP_VERSION=" + ${CI_COMMIT_SHORT_SHA} >> .env
     #- echo "VUE_APP_VERSION=" + ${CI_COMMIT_SHORT_SHA} >> .env.production
     - echo "VUE_APP_API_APP=https://api.dev.socket.messenkrypt.xyz" >> .env
     - echo "VUE_APP_API_APP=https://api.dev.socket.messenkrypt.xyz" >> .env.production
     - echo "VUE_APP_DOWNLOAD_ANDROID=https://dl.messenkrypt.com/apk-develop/messenkrypt-latest.apk" >> .env
     - echo "VUE_APP_DOWNLOAD_ANDROID=https://dl.messenkrypt.com/apk-develop/messenkrypt-latest.apk" >> .env.production
     - cat .env .env.production
  cache:
    paths:
      - .env
      - .env.production
  artifacts:
    paths:
      - .env
      - .env.production
  only:
    - develop

init-master:
  stage: init
  script:
     - echo "VUE_APP_ROOT_API=https://api.messenkrypt.com" > .env
     - echo "VUE_APP_ROOT_API=https://api.messenkrypt.com" > .env.production
     #- echo "VUE_APP_VERSION=" + ${CI_COMMIT_SHORT_SHA} >> .env
     #- echo "VUE_APP_VERSION=" + ${CI_COMMIT_SHORT_SHA} >> .env.production
     - echo "VUE_APP_API_APP=https://api.beta.socket.messenkrypt.com" >> .env
     - echo "VUE_APP_API_APP=https://api.beta.socket.messenkrypt.com" >> .env.production
     - echo "VUE_APP_DOWNLOAD_ANDROID=https://dl.messenkrypt.com/apk-beta/messenkrypt-latest.apk" >> .env
     - echo "VUE_APP_DOWNLOAD_ANDROID=https://dl.messenkrypt.com/apk-beta/messenkrypt-latest.apk" >> .env.production
     - cat .env .env.production
  artifacts:
    paths:
      - .env
      - .env.production
  only:
    - master

build:
   stage: build
   script:
     - export VUE_APP_VERSION=$CI_COMMIT_SHORT_SHA
     - npm run build
   artifacts:
     paths:
       - dist/
                
deploys3:
  image: "python:latest"  # We use python because there is a well-working AWS Sdk
  stage: deploy
  before_script:
    - pip install awscli # Install the SDK
  script:
    - aws s3 sync dist/ s3://${BUCKET_NAME}-${CI_COMMIT_REF_NAME} --delete --acl public-read # Replace example-bucket with your bucket
  environment:
    name: ${CI_COMMIT_REF_NAME}
    url: http://${BUCKET_NAME}-${CI_COMMIT_REF_NAME}.s3-website.${AWS_DEFAULT_REGION}.amazonaws.com/  # This is the url of the bucket we saved before
    #on_stop: clean_s3 # When the branch is merged, we clean up after ourself       

invalid-cloufront-develop:
  image: "python:latest"  # We use python because there is a well-working AWS Sdk
  stage: deploy
  before_script:
    - pip install awscli # Install the SDK
  script:
    - aws cloudfront create-invalidation --distribution-id EWF5MIMSY850U --paths "/*"
  environment:
    name: ${CI_COMMIT_REF_NAME}
    url: https://dev.messenkrypt.com  # This is the url of the bucket we saved before
    #on_stop: clean_s3 # When the branch is merged, we clean up after ourself       
  only:
    - develop

invalid-cloufront-master:
  image: "python:latest"  # We use python because there is a well-working AWS Sdk
  stage: deploy
  before_script:
    - pip install awscli # Install the SDK
  script:
    - aws cloudfront create-invalidation --distribution-id E33T3QKP28HA3A --paths "/*"
  environment:
    name: ${CI_COMMIT_REF_NAME}
    url: https://messenkrypt.com  # This is the url of the bucket we saved before
    #on_stop: clean_s3 # When the branch is merged, we clean up after ourself       
  only:
    - master
